var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export const isUrlValid = (_a) => __awaiter(void 0, [_a], void 0, function* ({ url, confirmExistenceOfUrl, }) {
    // Step 1: Validate URL format
    let parsedUrl;
    try {
        parsedUrl = new URL(url);
    }
    catch (e) {
        // If URL constructor throws, it's not a valid URL format
        return false;
    }
    if (!confirmExistenceOfUrl) {
        return true;
    }
    // Step 2: Attempt to fetch the URL using a HEAD request
    try {
        const response = yield fetch(parsedUrl.toString(), { method: "HEAD" });
        // Considering HTTP 200-level responses as "valid"
        return response.ok;
    }
    catch (e) {
        // If there's a network error or something else preventing the request
        return false;
    }
});
//# sourceMappingURL=isUrlValid.js.map